

#include "mpi.h"
#include <stdio.h>

#define BUF_SIZE 128

int main(int argc, char *argv[])
{
  int i, n, myrank, counter, slen;
  char txt[BUF_SIZE];
  
  // setup
  int s = MPI_Init(&argc, &argv);
  if(s!=MPI_SUCCESS) {
    fprintf(stderr, "Error MPI_Init\n");
    return -1;
  }

  // get information about who I am among how many  
  MPI_Comm_size(MPI_COMM_WORLD, &n);
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);

  slen = sprintf(txt, "Hello World, from proc. %d", myrank);
  
  // send/receive message of length slen
  if(myrank==0) {
    printf("%s\n", txt);
    for(i = 1; i < n; i++) {
      MPI_Recv(txt, slen, MPI_CHAR, i, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("%s\n", txt);
    }
  } else {
    MPI_Send(txt, slen, MPI_CHAR, 0, 0, MPI_COMM_WORLD);
  }

  MPI_Finalize();
  
  return 0;
}
